Index: /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/helpers/VerificationServices.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/helpers/VerificationServices.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/helpers/VerificationServices.java	(revision 1632)
@@ -2,4 +2,5 @@
 
 import java.text.SimpleDateFormat;
+import java.util.ArrayList;
 import java.util.Calendar;
 import java.util.Date;
@@ -535,7 +536,46 @@
 	
 	
+	private static TreeObject findTreeObject(ClassInstantiation ci, TreeObject objectFromOtherClassInstantiation){
+		
+		for (TreeObject treeObject : ci.getAllTreeObjects()) {
+			
+			String name = treeObject.getName();
+			String dotPath = treeObject.getDotPath();
+			Element element = treeObject.getUmlElement();
+			
+			if (name.equals(objectFromOtherClassInstantiation.getName())
+					&& dotPath.equals(objectFromOtherClassInstantiation.getDotPath())
+					&& element.equals(objectFromOtherClassInstantiation.getUmlElement())) {
+				return treeObject;
+			}
+		}
+		return null;
+	}
 	
 	
 	public static List<TreeObject> getClientsTreeItems(ClassInstantiation ci, TreeObject treeItem, HashSet<TreeObject> collectedItems, boolean onlyMandatoryClients) {
+		
+		/*
+		 * TODO: sometimes treeItem is null. find the bug...
+		 */
+		if (treeItem == null) {
+			return new ArrayList<TreeObject>();
+		}
+
+		/*
+		 * Sometimes the passed treeItem is not contained within the passed instantiation.
+		 * This may happen when instantiations were cashed and or recreated before being passed. 
+		 * In order to avoid confusion we first make sure that we find the 
+		 * right treeObject inside the passed instantiation based on
+		 * the name, dotPath and the UML element of the passed treeItem.  
+		 */
+		if (!ci.getAllTreeObjects().contains(treeItem)) {
+			treeItem = findTreeObject(ci, treeItem);
+		}
+
+		if (treeItem == null) {
+			// empty
+			return new ArrayList<TreeObject>();
+		}
 		
 		HashSet<TreeObject> collectedItem_temp = new HashSet<TreeObject>();
Index: /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/instantiation/ClassInstantiation.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/instantiation/ClassInstantiation.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/instantiation/ClassInstantiation.java	(revision 1632)
@@ -60,6 +60,6 @@
 import org.eclipse.uml2.uml.Type;
 import org.openmodelica.modelicaml.common.constants.Constants;
+import org.openmodelica.modelicaml.common.services.ModelicaMLServices;
 import org.openmodelica.modelicaml.common.services.StringUtls;
-import org.openmodelica.modelicaml.common.services.UmlServices;
 import org.openmodelica.modelicaml.common.valuebindings.helpers.BindingsDataCollector;
 
@@ -218,7 +218,7 @@
 						
 						for (Property propertyInherited : inheritedProperties) { // iterate over the class attributes
-							String nameInheritedProperty = propertyInherited.getName();
+							String nameInheritedProperty = StringUtls.replaceSpecChar(propertyInherited.getName());
 							for (Property propertyPassed : passedAList) { // iterate over the passed list
-								String namePropertyPassed = propertyPassed.getName();
+								String namePropertyPassed = StringUtls.replaceSpecChar(propertyPassed.getName());
 								if (nameInheritedProperty.equals(namePropertyPassed)) { // if a duplicate is found ...
 									mergedSet.remove(propertyInherited); // remove duplicate from the final list.
@@ -253,8 +253,10 @@
 	
 			String newDotPath = "";
+			String name = StringUtls.replaceSpecChar(property.getName());
+			
 			if (!dotPath.equals("")) {
-				newDotPath = dotPath + "." + property.getName();
+				newDotPath = dotPath + "." + name;
 			} else {
-				newDotPath = property.getName();
+				newDotPath = name;
 			}
 	
@@ -264,5 +266,5 @@
 				HashSet<String> modifications = null;
 				
-				TreeParent child = new TreeParent(property.getName(), property, firstLevelComponent, newDotPath, true, false, modifications, selectedClass, includeStateMachines);
+				TreeParent child = new TreeParent(name, property, firstLevelComponent, newDotPath, true, false, modifications, selectedClass, includeStateMachines);
 				parent.addChild(child);
 				allTreeObjects.add(child);
@@ -297,5 +299,5 @@
 				
 				HashSet<String> modifications = null;
-				TreeParent newParent = new TreeParent(property.getName(), property, firstLevelComponent, newDotPath, false, false, modifications, selectedClass, includeStateMachines);
+				TreeParent newParent = new TreeParent(name, property, firstLevelComponent, newDotPath, false, false, modifications, selectedClass, includeStateMachines);
 				parent.addChild(newParent);
 				allTreeObjects.add(newParent);
@@ -312,5 +314,6 @@
 				newParent.setComponentType(pType); 
 				
-				if (pType instanceof Class && (Class) pType != aClass && !(pType instanceof Stereotype)) { // TODO: // prevent endless looping, implement it correctly!
+				// TODO: // prevent endless looping, implement it correctly!
+				if (pType instanceof Class && (Class) pType != aClass && !(pType instanceof Stereotype)) { 
 					buildNextTreeLevel((Class) pType, firstLevelComponent, newParent, newDotPath);
 				}
@@ -332,11 +335,28 @@
 	 * @return the component modifications
 	 */
+//	@SuppressWarnings("unchecked")
+//	public HashSet<String> getComponentModifications(Property component) {
+//		HashSet<String> mList = new HashSet<String>();
+//		String stereotypeName = getFirstModelicaMLComponentStereotypeName(component);
+//		List<String> modificationList = new ArrayList<String>();
+//		if (stereotypeName != null) {
+//			Object o = UmlServices.getStereotypeValue((Element) component, getFirstModelicaMLComponentStereotypeName(component), "modification");
+//			if (o instanceof List<?>) {
+//				modificationList = (List<String>) o;
+//			}
+//			for (String string : modificationList) {
+//				mList.add(StringUtls.removeOutterBraces(string));
+//			}
+//		}
+//		return mList;
+//	}
+	
 	@SuppressWarnings("unchecked")
 	public HashSet<String> getComponentModifications(Property component) {
 		HashSet<String> mList = new HashSet<String>();
-		String stereotypeName = getFirstModelicaMLComponentStereotypeName(component);
+		Stereotype stereotype = ModelicaMLServices.getFirstModelicaMLComponentStereotype(component);
 		List<String> modificationList = new ArrayList<String>();
-		if (stereotypeName != null) {
-			Object o = UmlServices.getStereotypeValue((Element) component, getFirstModelicaMLComponentStereotypeName(component), "modification");
+		if (stereotype != null) {
+			Object o = component.getValue(stereotype, Constants.propertyName_modification);
 			if (o instanceof List<?>) {
 				modificationList = (List<String>) o;
@@ -354,18 +374,15 @@
 		
 		for (Generalization generalization : extendsRelations) {
-			Stereotype stereotype = getGeneralizationStereotype(generalization);
-			if ( stereotype != null ) {
-				EList<String> modList = getGeneralizationModifications(generalization, stereotype);
-				for (String string : modList) {
-					addToModificationList(string, dotPath, aClass);
-				}
-				// recursive call to the next inheritance level
-				EList<Element> targets = generalization.getTargets();
-				for (Element element : targets) {
-					if (element instanceof Class) {
-						addInheritedClassModifications((Class)element, dotPath); 
-					}
-				}
-				
+			EList<String> modList = getGeneralizationModifications(generalization);
+			for (String string : modList) {
+				addToModificationList(string, dotPath, aClass);
+			}
+			
+			// recursive call to the next inheritance level
+			EList<Element> targets = generalization.getTargets();
+			for (Element element : targets) {
+				if (element instanceof Class) {
+					addInheritedClassModifications((Class)element, dotPath); 
+				}
 			}
 		}
@@ -514,5 +531,5 @@
 
 					boolean skip = false;
-					if (predefinedPropertyName != null && !p.getName().equals(predefinedPropertyName)) {
+					if (predefinedPropertyName != null && !StringUtls.replaceSpecChar(p.getName()).equals(predefinedPropertyName)) {
 						skip = true;
 					}
@@ -520,12 +537,13 @@
 					if (!skip) {
 						String newDotPath = "";
+						String name = StringUtls.replaceSpecChar(p.getName());
 						if (!dotPath.equals("")) {
-							newDotPath = dotPath + "." + p.getName();
+							newDotPath = dotPath + "." + name;
 						} else {
-							newDotPath = p.getName();
+							newDotPath = name;
 						}
 
 						HashSet<String> modifications = null;
-						TreeParent child = new TreeParent(p.getName(), p, firstLevelComponent, newDotPath, true, false, modifications, selectedClass, false);
+						TreeParent child = new TreeParent(name, p, firstLevelComponent, newDotPath, true, false, modifications, selectedClass, false);
 						parent.addChild(child);
 						allTreeObjects.add(child);
@@ -576,21 +594,21 @@
 	
 
-	/**
-	 * Gets the generalization stereotype.
-	 * 
-	 * @param extendsRelation
-	 *            the extends relation
-	 * @return the generalization stereotype
-	 */
-	private static Stereotype getGeneralizationStereotype(Generalization extendsRelation) {
-		Stereotype stereotype = null;
-		if (UmlServices.hasStereotype((Element) extendsRelation, "ExtendsRelation"))
-			return stereotype = extendsRelation.getAppliedStereotype("ModelicaML::ModelicaRelationsConstructs::ExtendsRelation");
-		
-		if (UmlServices.hasStereotype((Element) extendsRelation, "TypeRelation"))
-			return stereotype = extendsRelation.getAppliedStereotype("ModelicaML::ModelicaRelationsConstructs::TypeRelation");
-		
-		return stereotype;
-	}
+//	/**
+//	 * Gets the generalization stereotype.
+//	 * 
+//	 * @param extendsRelation
+//	 *            the extends relation
+//	 * @return the generalization stereotype
+//	 */
+//	private static Stereotype getGeneralizationStereotype(Generalization extendsRelation) {
+//		Stereotype stereotype = null;
+//		if (UmlServices.hasStereotype((Element) extendsRelation, "ExtendsRelation"))
+//			return stereotype = extendsRelation.getAppliedStereotype("ModelicaML::ModelicaRelationsConstructs::ExtendsRelation");
+//		
+//		if (UmlServices.hasStereotype((Element) extendsRelation, "TypeRelation"))
+//			return stereotype = extendsRelation.getAppliedStereotype("ModelicaML::ModelicaRelationsConstructs::TypeRelation");
+//		
+//		return stereotype;
+//	}
 
 	/**
@@ -603,11 +621,32 @@
 	 * @return the generalization modifications
 	 */
+//	@SuppressWarnings("unchecked")
+//	private EList<String> getGeneralizationModifications(Generalization extendsRelation, Stereotype stereotype) {
+//		EList<String> mList = new BasicEList<String>();
+//		
+//		List<String> modificationList = new ArrayList<String>();
+//		if (stereotype != null) {
+//			Object o = UmlServices.getStereotypeValue((Element) extendsRelation, stereotype.getName(), "modification");
+//			if (o instanceof List<?>) {
+//				modificationList = (List<String>) o;
+//			}
+//			mList.addAll(modificationList);
+//		}
+//		return mList;
+//	}
+	
 	@SuppressWarnings("unchecked")
-	private EList<String> getGeneralizationModifications(Generalization extendsRelation, Stereotype stereotype) {
+	private EList<String> getGeneralizationModifications(Generalization extendsRelation) {
 		EList<String> mList = new BasicEList<String>();
 		
 		List<String> modificationList = new ArrayList<String>();
+		
+		Stereotype stereotype = extendsRelation.getAppliedStereotype(Constants.stereotypeQName_ExtendsRelation);
+		if (stereotype == null) {
+			stereotype = extendsRelation.getAppliedStereotype(Constants.stereotypeQName_TypeRelation);
+		}
+		
 		if (stereotype != null) {
-			Object o = UmlServices.getStereotypeValue((Element) extendsRelation, stereotype.getName(),"modification");
+			Object o = extendsRelation.getValue(stereotype, Constants.propertyName_modification);
 			if (o instanceof List<?>) {
 				modificationList = (List<String>) o;
@@ -618,19 +657,33 @@
 	}
 
-	/**
-	 * Gets the first modelica ml component stereotype name.
-	 * 
-	 * @param property
-	 *            the property
-	 * @return the first modelica ml component stereotype name
-	 */
-	private String getFirstModelicaMLComponentStereotypeName(Property property) {
-		String name = null;
-		if (UmlServices.hasStereotype((Element) property, "Component")) return "Component";
-		if (UmlServices.hasStereotype((Element) property, "Variable")) return "Variable";
-		if (UmlServices.hasStereotype((Element) property, "RequirementInstance")) return "RequirementInstance";
-		if (UmlServices.hasStereotype((Element) property, "CalculatedProperty")) return "CalculatedProperty";
-		return name;
-	}
+//	/**
+//	 * Gets the first modelica ml component stereotype name.
+//	 * 
+//	 * @param property
+//	 *            the property
+//	 * @return the first modelica ml component stereotype name
+//	 */
+//	private String getFirstModelicaMLComponentStereotypeName(Property property) {
+//		String name = null;
+//		if (UmlServices.hasStereotype((Element) property, "Component")) return "Component";
+//		if (UmlServices.hasStereotype((Element) property, "Variable")) return "Variable";
+//		if (UmlServices.hasStereotype((Element) property, "RequirementInstance")) return "RequirementInstance";
+//		if (UmlServices.hasStereotype((Element) property, "CalculatedProperty")) return "CalculatedProperty";
+//		return name;
+//	}
+	
+//	private Stereotype getFirstModelicaMLComponentStereotype(Property property) {
+//		Stereotype stereotype = null;
+//		
+//		stereotype = property.getAppliedStereotype(Constants.stereotypeQName_Component);
+//		if (stereotype != null) { return stereotype; }
+//		stereotype = property.getAppliedStereotype(Constants.stereotypeQName_Variable);
+//		if (stereotype != null) { return stereotype; }
+//		stereotype = property.getAppliedStereotype(Constants.stereotypeQName_RequirementInstance);
+//		if (stereotype != null) { return stereotype; }
+//		stereotype = property.getAppliedStereotype(Constants.stereotypeQName_CalculatedProperty);
+//		if (stereotype != null) { return stereotype; }
+//		return stereotype ;
+//	}
 	
 	
@@ -907,4 +960,16 @@
 
 	public HashSet<Element> getAllMediators() {
+		if (getValueBindingsDataCollector().getAllMediators() != null ) {
+
+			if (allMediators == null) {
+				/*
+				 * TODO: not clear when this happens
+				 */
+				return getValueBindingsDataCollector().getAllMediators();
+			}
+			else {
+				this.allMediators.addAll(getValueBindingsDataCollector().getAllMediators());
+			}
+		}
 		return allMediators;
 	}
Index: /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/instantiation/ModificationManager.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/instantiation/ModificationManager.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/instantiation/ModificationManager.java	(revision 1632)
@@ -53,5 +53,4 @@
 import org.openmodelica.modelicaml.common.services.EditorServices;
 import org.openmodelica.modelicaml.common.services.StringUtls;
-import org.openmodelica.modelicaml.common.services.UmlServices;
 
 
@@ -425,5 +424,6 @@
 
 		// apply ModelicaML stereotype to the properties
-		if ( !UmlServices.hasStereotype(p, Constants.stereotypeQName_Variable) ) {
+//		if ( !UmlServices.hasStereotype(p, Constants.stereotypeQName_Variable) ) {
+		if ( p.getAppliedStereotype(Constants.stereotypeQName_Variable) == null) {
 			final Stereotype pStereotype = p.getApplicableStereotype(Constants.stereotypeQName_Variable);
 			//########## storing start
@@ -567,5 +567,6 @@
 		
 		// apply ModelicaML stereotype to the properties
-		if ( !UmlServices.hasStereotype(p, Constants.stereotypeQName_Variable) ) {
+//		if ( !UmlServices.hasStereotype(p, Constants.stereotypeQName_Variable) ) {
+		if ( p.getAppliedStereotype(Constants.stereotypeQName_Variable) == null ) {
 			final Stereotype pStereotype = p.getApplicableStereotype(Constants.stereotypeQName_Variable);
 			
Index: /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/instantiation/TreeObject.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/instantiation/TreeObject.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/instantiation/TreeObject.java	(revision 1632)
@@ -52,5 +52,4 @@
 import org.openmodelica.modelicaml.common.constants.Constants;
 import org.openmodelica.modelicaml.common.services.StringUtls;
-import org.openmodelica.modelicaml.common.services.UmlServices;
 
 
@@ -115,5 +114,5 @@
 	
 	/** The final modification description. */
-	private String finalModificationDescription = null;
+//	private String finalModificationDescription = null;
 	
 	// TODO: implement getter and setter
@@ -231,5 +230,5 @@
 			Stereotype stereotype = property.getAppliedStereotype(stereotypeQName_Variable );
 			if (stereotype != null) {
-				Object declarationEquationOrAssignment = UmlServices.getStereotypeValue((Element)property, stereotype.getName(), "declarationEquationOrAssignment");
+				Object declarationEquationOrAssignment = property.getValue(stereotype, Constants.propertyName_declarationEquationOrAssignment);
 				if (declarationEquationOrAssignment instanceof String) {
 					return this.declaration = " " + declarationEquationOrAssignment.toString().trim();
@@ -489,12 +488,38 @@
 	 * @return the boolean
 	 */
+//	private Boolean isInputOrOutputVariable(Property property, String causalityString){
+//		Boolean result = false;
+//		Object causality = null;
+//		if (property instanceof Port) {
+//			causality = UmlServices.getStereotypeValue(property, Constants.stereotypeQName_ConnectionPort, Constants.propertyName_causality);				
+//		}
+//		else if (property instanceof Property) {
+//			causality = UmlServices.getStereotypeValue(property, Constants.stereotypeQName_Variable, Constants.propertyName_causality);								
+//		}
+//
+//		if (causality != null) {
+//			String causalityValue = ((EnumerationLiteral)causality).getName(); 
+//			if (causalityValue.equals(causalityString) ) {
+//				result = true;
+//			}
+//		}
+//		return result;
+//	}
+	
+	
 	private Boolean isInputOrOutputVariable(Property property, String causalityString){
 		Boolean result = false;
 		Object causality = null;
 		if (property instanceof Port) {
-			causality = UmlServices.getStereotypeValue(property, Constants.stereotypeQName_ConnectionPort, Constants.propertyName_causality);				
+			Stereotype sPort = property.getAppliedStereotype(Constants.stereotypeQName_ConnectionPort);
+			if (sPort != null) {
+				causality = property.getValue(sPort, Constants.propertyName_causality);
+			}
 		}
 		else if (property instanceof Property) {
-			causality = UmlServices.getStereotypeValue(property, Constants.stereotypeQName_Variable, Constants.propertyName_causality);								
+			Stereotype sVariable = property.getAppliedStereotype(Constants.stereotypeQName_Variable);
+			if (sVariable != null) {
+				causality = property.getValue(sVariable, Constants.propertyName_causality);
+			}
 		}
 
@@ -507,4 +532,5 @@
 		return result;
 	}
+	
 	
 	
@@ -674,5 +700,5 @@
 	 */
 	@Override
-	public Object getAdapter(java.lang.Class adapter) {
+	public Object getAdapter(@SuppressWarnings("rawtypes") java.lang.Class adapter) {
 		if (adapter == EObject.class) {
 			if (isRoot) { 
Index: /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/services/ModelicaMLServices.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/services/ModelicaMLServices.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/services/ModelicaMLServices.java	(revision 1632)
@@ -42,4 +42,5 @@
 import org.eclipse.uml2.uml.Model;
 import org.eclipse.uml2.uml.NamedElement;
+import org.eclipse.uml2.uml.Property;
 import org.eclipse.uml2.uml.Stereotype;
 import org.openmodelica.modelicaml.common.constants.Constants;
@@ -47,7 +48,4 @@
 import org.openmodelica.modelicaml.common.instantiation.TreeObject;
 import org.openmodelica.modelicaml.common.utls.ResourceManager;
-//import org.eclipse.papyrus.core.utils.BusinessModelResolver;
-//import org.eclipse.papyrus.resource.uml.UmlModel;
-//import org.eclipse.papyrus.ui.toolbox.notification.builders.NotificationBuilder;
 
 public class ModelicaMLServices {
@@ -248,4 +246,19 @@
 		}
 		return false;
+	}
+	
+	
+	public static Stereotype getFirstModelicaMLComponentStereotype(Property property) {
+		Stereotype stereotype = null;
+		
+		stereotype = property.getAppliedStereotype(Constants.stereotypeQName_Component);
+		if (stereotype != null) { return stereotype; }
+		stereotype = property.getAppliedStereotype(Constants.stereotypeQName_Variable);
+		if (stereotype != null) { return stereotype; }
+		stereotype = property.getAppliedStereotype(Constants.stereotypeQName_RequirementInstance);
+		if (stereotype != null) { return stereotype; }
+		stereotype = property.getAppliedStereotype(Constants.stereotypeQName_CalculatedProperty);
+		if (stereotype != null) { return stereotype; }
+		return stereotype ;
 	}
 	
Index: /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/valuebindings/helpers/BindingsDataCollector.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/valuebindings/helpers/BindingsDataCollector.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.common/src/org/openmodelica/modelicaml/common/valuebindings/helpers/BindingsDataCollector.java	(revision 1632)
@@ -272,4 +272,6 @@
 										else {
 											//TODO: log that the mediator or its providers was discarded because they are not used in the instantiation tree.
+											String message = "DISCARDED: Provider '" + ((NamedElement)element).getQualifiedName() + "' for mediator '"+mediator.getQualifiedName()+"' is not used in the instantiated class.";
+											addToLog(message);
 										}
 									}
Index: /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/dialogs/ScenarioBasedVerificationReportDialog.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/dialogs/ScenarioBasedVerificationReportDialog.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/dialogs/ScenarioBasedVerificationReportDialog.java	(revision 1632)
@@ -1248,5 +1248,5 @@
 			item.setData(data);
 
-			// Add clients (isMandatory, binding)
+			// Add clients
 			getClientItems(ci, item, VeM, requirement);
 			
Index: /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/dialogs/SelectScenariosAndRequirementsDialog.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/dialogs/SelectScenariosAndRequirementsDialog.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/dialogs/SelectScenariosAndRequirementsDialog.java	(revision 1632)
@@ -906,5 +906,5 @@
 					lineDelimiterString + 
 					"\nTest Scenario: '"+((NamedElement)testScenario).getName()+"'("+((NamedElement)testScenario).getQualifiedName()+")" +
-					getAdditionalModelsString(tsmc.getRequiredModels_testScenario(), tsmc, testScenario) 
+					getAdditionalModelsString(tsmc.getRequiredModels_scenario(), tsmc, testScenario) 
 					;
 			
@@ -1012,5 +1012,5 @@
 	private String getUnsatisfiedClients(String prefix, Element element, VeMScenarioReqCombinationsCreator tsmc){
 		String string = "";
-		String unsatisfiedClientsString = tsmc.getClientsDotPathAsString(tsmc.getUnsatisfiedRequiredClients(element));
+		String unsatisfiedClientsString = tsmc.getClientsDotPathAsString(tsmc.getUnsatisfiedMandatoryClients(element));
 		if (!unsatisfiedClientsString.trim().equals("")) {
 			string = prefix + "- unsatisfied required clients: " + "\n";
Index: /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/generators/CreatorValueBinding.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/generators/CreatorValueBinding.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/generators/CreatorValueBinding.java	(revision 1632)
@@ -88,5 +88,5 @@
 	 * even if the default value is set in its declaration.
 	 */
-	private HashSet<TreeObject> allRequiredClientsFound = new HashSet<TreeObject>();
+	private HashSet<TreeObject> allMandatoryClientsFound = new HashSet<TreeObject>();
 	
 	
@@ -229,6 +229,6 @@
 				
 				// add to required clients list
-				if (deriveCodeHelper.isRequiredClient()) {
-					allRequiredClientsFound.add(item);
+				if (deriveCodeHelper.isMandatoryClient()) {
+					allMandatoryClientsFound.add(item);
 					if (code == null) {
 						if ( !onlySimulate ) {
@@ -343,10 +343,10 @@
 	}
 
-	public void setAllRequiredClientsFound(HashSet<TreeObject> allRequiredClientsFound) {
-		this.allRequiredClientsFound = allRequiredClientsFound;
-	}
-
-	public HashSet<TreeObject> getAllRequiredClientsFound() {
-		return allRequiredClientsFound;
+	public void setAllMandatoryClientsFound(HashSet<TreeObject> allMandatoryClientsFound) {
+		this.allMandatoryClientsFound = allMandatoryClientsFound;
+	}
+
+	public HashSet<TreeObject> getAllMandatoryClientsFound() {
+		return allMandatoryClientsFound;
 	}
 	
Index: /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/generators/GeneratorVeMRequirementsBased.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/generators/GeneratorVeMRequirementsBased.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/generators/GeneratorVeMRequirementsBased.java	(revision 1632)
@@ -361,5 +361,5 @@
 		 * Determine if there were models for which no correct bindings could be generated
 		 */
-		HashSet<TreeObject> allMandClients = vbc.getAllRequiredClientsFound();
+		HashSet<TreeObject> allMandClients = vbc.getAllMandatoryClientsFound();
 		HashSet<TreeObject> allMandClientsWithPossibleBindins = vbc.getAllClientsWithPossibleBindingCodeDerivation();
 		
Index: /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/generators/GeneratorVeMScenariosBased.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/generators/GeneratorVeMScenariosBased.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/generators/GeneratorVeMScenariosBased.java	(revision 1632)
@@ -488,8 +488,11 @@
 					HashSet<Element> requirements = tsmc.getRequirements();
 					for (Element requirement : requirements) {
-						if (tsmc.getUnsatisfiedRequiredClients(requirement) != null) {
+
+						//if NOT all mandatory are satisfied 
+						if (tsmc.getUnsatisfiedMandatoryClients(requirement) != null) {
 							requirementsDiscarded.add(requirement);
 						}
-						else {
+						// if requirement has clients at all
+						else if (tsmc.getModelClients(requirement) != null) {
 							requirementsToBeInstantiated.add(requirement);
 						}
@@ -765,5 +768,5 @@
 						 * one provider used in the combination.
 						 */
-						createAdditionalModels(simulationModel, tsmc.getAdditionalTestScenarioModels(true), 
+						createAdditionalModels(simulationModel, tsmc.getAdditionalScenarioModels(true), 
 								Constants.verificationScenarioPropertyNamePrefix + Constants.additionalModelPrefix);
 						
@@ -982,5 +985,5 @@
 						 * Determine if there were models for which no correct bindings could be generated
 						 */
-						HashSet<TreeObject> allMandClients = vbc.getAllRequiredClientsFound();
+						HashSet<TreeObject> allMandClients = vbc.getAllMandatoryClientsFound();
 						HashSet<TreeObject> allMandClientsWithPossibleBindings = vbc.getAllClientsWithPossibleBindingCodeDerivation();
 						HashSet<TreeObject> allMandClientsWithUserDecisionRequired = vbc.getAllClientsWithUserDecisionRequiredForCodeDerivation();
Index: /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/structures/VeMReqCombinationsCreator.java
===================================================================
--- /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/structures/VeMReqCombinationsCreator.java	(revision 1631)
+++ /trunk/modelicaml/org.openmodelica.modelicaml.helper/src/org/openmodelica/modelicaml/helper/structures/VeMReqCombinationsCreator.java	(revision 1632)
@@ -389,6 +389,6 @@
 		vbc.updateAllBindings(valueMediatorsPackage, null, treeParentToStartTheCheckOn, virtualInstantiationTreeRoot, false, true, false, true);
 		
-		if ( vbc.getAllRequiredClientsFound().size() > 0 
-				&& !vbc.getAllClientsWithPossibleBindingCodeDerivation().containsAll(vbc.getAllRequiredClientsFound())) {
+		if ( vbc.getAllMandatoryClientsFound().size() > 0 
+				&& !vbc.getAllClientsWithPossibleBindingCodeDerivation().containsAll(vbc.getAllMandatoryClientsFound())) {
 			allRequiredClientsAreSatisfied = false;
 		}
@@ -396,5 +396,5 @@
 		// Collect all mandatory clients that are not satisfied.
 		HashSet<TreeObject> unsatisfiedRequiredClients = new HashSet<TreeObject>();
-		unsatisfiedRequiredClients.addAll(vbc.getAllRequiredClientsFound());
+		unsatisfiedRequiredClients.addAll(vbc.getAllMandatoryClientsFound());
 		unsatisfiedRequiredClients.removeAll(vbc.getAllClientsWithPossibleBindingCodeDerivation());
 
